/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id:  SMTPServiceUnitManager.java 154 2006-03-27 15:30:10Z rbarraza $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.binding.smtpbc;

import java.io.File;
import javax.jbi.JBIException;
import javax.jbi.component.Bootstrap;
import javax.jbi.component.InstallationContext;
import javax.management.ObjectName;

/**
 * 
 * @version $Rev: 250 $Date: {date}
 * @since Petals 1.0
 * @author alouis, Rocio BARRAZA - eBMWebsourcing
 * 
 */
public class SMTPBCBootstrapImpl implements Bootstrap {

    InstallationContext context;

    public void cleanUp() throws JBIException {

    }

    public ObjectName getExtensionMBeanName() {
        return null;
    }

    public void init(InstallationContext installContext) throws JBIException {
        context = installContext;
    }

    public void onInstall() throws JBIException {
        File installPath = new File(context.getInstallRoot());

        File certificate = new File(installPath, "certificate");

        certificate.mkdirs();

        // copy certificate files to the directory certificates

        File[] metaInfFiles = new File(installPath, "META-INF").listFiles();
        for (File file : metaInfFiles) {
            if (file.getName().endsWith(".p12")
                || file.getName().endsWith(".csr")
                || file.getName().endsWith(".crt")) {
                file.renameTo(new File(certificate, file.getName()));
            }
        }
    }

    public void onUninstall() throws JBIException {
        // Delete all certificates 

        File certifDir = new File(context.getInstallRoot(), "certificate");

        File[] files = certifDir.listFiles();
        if (files != null)
            for (File file : files) {
                file.delete();
            }
    }

}
