/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: XlinkerClient.java 154 19 avr. 2006 wjoseph $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.binding.xlinkerbc.client;

import javax.xml.namespace.QName;
import javax.xml.rpc.Call;
import javax.xml.rpc.ParameterMode;
import javax.xml.rpc.Service;
import javax.xml.rpc.ServiceFactory;
import javax.xml.rpc.encoding.XMLType;

/**
 * This is a class used only for testing purpose
 * 
 * @version $Rev: 250 $ $Date: 2006-04-21 14:20:57 +0200 (ven, 21 avr 2006) $
 * @since Petals 1.0
 * @author wjoseph - EBM Webousourcing
 * 
 */
public final class XlinkerClient {

    private static final String SERVICE_FACTORY_PROPERTY = "javax.xml.rpc.ServiceFactory";

    private static final String SERVICE_FACTORY_IMPL_ACT = "org.act.soap.client.ServiceFactory";

    private static final String MESSAGE_FACTORY_PROPERTY = "javax.xml.soap.MessageFactory";

    private static final String MESSAGE_FACTORY_IMPL_ACT = "org.act.soap.message.MessageFactoryImpl";

    private static final String SOAP_CON_FACTORY_PROPERTY = "javax.xml.soap.SOAPConnectionFactory";

    private static final String SOAP_CON_FACTORY_IMPL_ACT = "org.act.soap.message.transport.ConnectionFactoryImpl";

    private XlinkerClient() {

    }

    public static void main(String[] args) throws Exception {
        testEcho();
    }

    public static void testEcho() throws Exception {
        // setProperty of Factory
        System.setProperty(SERVICE_FACTORY_PROPERTY, SERVICE_FACTORY_IMPL_ACT);
        System.setProperty(MESSAGE_FACTORY_PROPERTY, MESSAGE_FACTORY_IMPL_ACT);
        System
                .setProperty(SOAP_CON_FACTORY_PROPERTY,
                        SOAP_CON_FACTORY_IMPL_ACT);

        Service service = ServiceFactory.newInstance().createService(
                new QName(""));

        // construct a call object .
        Call call = service.createCall(new QName(""));
        call.setTargetEndpointAddress("http://localhost:8084/Helloworld");
        //call.setTargetEndpointAddress("http://localhost:8084//MortgageProfilingService");
        // call.setTargetEndpointAddress("http://localhost:8085/axis2/services/HelloworldService");
        // call.setTargetEndpointAddress("http://localhost:8085/axis2/services/MortgageProfiling");
        call.setOperationName(new QName("sayHello"));
        //call.setOperationName(new QName("orchestrate"));
        call.setReturnType(XMLType.XSD_STRING);
        call.addParameter("arg1", XMLType.XSD_STRING, ParameterMode.IN);
        String strRtn = (String) call.invoke(new Object[] {new String(
                "hello world!")});
        System.out.println("return String = " + strRtn);
    }
}
