package org.objectweb.petals.demo.mortgage.workflow;

import javax.jbi.JBIException;
import javax.jbi.component.Bootstrap;
import javax.jbi.component.InstallationContext;
import javax.management.ObjectName;

import org.w3c.dom.DocumentFragment;

/**
 * 
 * @author ofabre
 * 
 */
public class MortgageWorkflowBootstrapImpl implements Bootstrap {

    private InstallationContext installContext;

    public void cleanUp() throws JBIException {
        System.out
                .println("Bootstrap called to clean up allocated ressources.");

    }

    public ObjectName getExtensionMBeanName() {
        System.out.println("Bootstrap called to get ExtensionMBeanName.");
        return null;
    }

    public void init(InstallationContext installContext) throws JBIException {
        System.out.println("Bootstrap instance initiated.");
        this.installContext = installContext;
    }

    public void onInstall() throws JBIException {
        System.out.println("Bootstrap instance installed.");
        DocumentFragment f = installContext
                .getInstallationDescriptorExtension();
        if (f != null) {
            System.out
                    .println("Bootstrap contained an installation extension : "
                            + f.getFirstChild().getNodeName());
        }
    }

    public void onUninstall() throws JBIException {
        System.out.println("Bootstrap instance uninstalled.");

    }

}
