/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: JBIDescriptorTest.java 3:36:45 PM ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.tools.jbicommon.descriptor;

import org.objectweb.petals.tools.jbicommon.descriptor.JBIDescriptor;
import org.objectweb.petals.tools.jbicommon.descriptor.Services;

import junit.framework.TestCase;

/**
 * Test of the JBIDescriptor
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class JBIDescriptorTest extends TestCase {

    public void testGetters() {
        JBIDescriptor descriptor = new JBIDescriptor();
        Services services = new Services();
        descriptor.setServices(services);
        assertEquals(descriptor.getServices(), services);
        descriptor.setVersion(1.0);
        assertEquals(descriptor.getVersion(), 1.0);
        assertTrue(JBIDescriptor.isParentFirst("parent-first"));
        assertTrue(JBIDescriptor.isSelfFirst("self-first"));
        ComponentDescription componentDescription = new ComponentDescription();
        descriptor.setComponent(componentDescription);
        assertEquals(descriptor.getComponent(), componentDescription);
        ServiceAssembly serviceAssembly = new ServiceAssembly();
        descriptor.setServiceAssembly(serviceAssembly);
        assertEquals(serviceAssembly, descriptor.getServiceAssembly());
        SharedLibrary sharedLibrary = new SharedLibrary();
        descriptor.setSharedLibrary(sharedLibrary);
        assertEquals(sharedLibrary, descriptor.getSharedLibrary());
    }

}
